#include <IRremote.h>     //library for the IRremote
#include <Servo.h>        //library for the servos


const int RECV_PIN = 3; //the IR receiver pin
const int ledPin = LED_BUILTIN;
int led_state = LOW;
int right_treads=0;//controls the right treads of the robot
int left_treads=0;//controls the left treads of the robot
int speed=0;//the current speed of the treads of the robot
int set_speed=75;//the set speed of the treads of the robot

unsigned long timeout = 0;
unsigned long lastSignalTime = 0;
const unsigned long TIMEOUT_THRESHOLD =200;


Servo rservo;//naming a servo
Servo lservo;
String ButtonPressed; //a variable which is determined by the button pressed on the IR remote
IRrecv irrecv(RECV_PIN); // Create an IRrecv object
decode_results results; // Create a decode_results object


void setup() {
  lservo.attach(5);//sets the pin number for the servo
  rservo.attach(6);
  lservo.write(90);//tells the servo to stop
  rservo.write(90);

  Serial.begin(9600);//begins the serial monitor
  irrecv.enableIRIn();//a function that prepares the Ir sensor

  pinMode(ledPin, OUTPUT);

}

void loop() {
  if (irrecv.decode(&results)) {
    if (String(results.value, HEX) != "ffffffff"){ButtonPressed=String(results.value,HEX);}
    
    //These control what happens depending on the button pushed on the remote
    //to control treads just have left_treads/right_treads equal "1" or "-1",  1=clockwise  -1=counter-clockwise
    if(ButtonPressed=="ffa25d"){}
    if(ButtonPressed=="ff629d"){left_treads=-1;right_treads=1;}
    if(ButtonPressed=="ffe21d"){}
    if(ButtonPressed=="ff22dd"){left_treads=1;right_treads=1;}
    if(ButtonPressed=="ff02fd"){}
    if(ButtonPressed=="ffc23d"){left_treads=-1;right_treads=-1;}
    if(ButtonPressed=="ffe01f"){}
    if(ButtonPressed=="ffa857"){left_treads=1;right_treads=-1;}
    if(ButtonPressed=="ff906f"){}
    if(ButtonPressed=="ff6897"){}
    if(ButtonPressed=="ff9867"){}
    if(ButtonPressed=="ffb04f"){}
    if(ButtonPressed=="ff18e7"){}
    if(ButtonPressed=="ff7a85"){}
    if(ButtonPressed=="ff10ef"){}
    if(ButtonPressed=="ff38c7"){}
    if(ButtonPressed=="ff5aa5"){}
    if(ButtonPressed=="ff4ab5"){}
    irrecv.resume();//prepares Ir sensor for new results
    lastSignalTime = millis();
  }
  timeout = millis() - lastSignalTime;
  //Serial.println (left_treads);

  execute();
  

  if (timeout > TIMEOUT_THRESHOLD) {
    reset();
  }
  else{
    speed = set_speed;
    }
} 

void reset(){
  //ButtonPressed="0";
  left_treads=0;
  right_treads=0;
}


void execute(){

  lservo.write(90-(left_treads*(speed)));
  rservo.write(90-(right_treads*(speed)));
  Serial.println (ButtonPressed);
  if (millis()%500==0){if (led_state==LOW){led_state=HIGH;}else{led_state=LOW;}}
  digitalWrite(ledPin,led_state);
}

